| http://www.sim.no/ http://www.coin3d.org/

- Main Page
- Related Pages
- Modules
- Classes
- Files

- Class List
- Class Index
- Class Hierarchy
- Class Members

Public Types | Public Member Functions | Static Public Member Functions | Public Attributes | Protected Member Functions | Static Protected Member Functions | List of all members
SoWWWInline Class Reference
Node Classes

The SoWWWInline class is a node used to include data from an URL.If the URL is not a local file, the application is responsible for supplying a callback to a function which will fetch the data of the URL. More...

`#include <Inventor/nodes/SoWWWInline.h>`

Inheritance diagram for SoWWWInline:

## Public Types

enum | BboxVisibility { NEVER, UNTIL_LOADED, ALWAYS }
Public Types inherited from SoNode
enum | NodeType { INVENTOR = 0x0000, VRML1 = 0x0001, VRML2 = 0x0002, INVENTOR_1 = 0x0004, INVENTOR_2_0 = 0x0008, INVENTOR_2_1 = 0x0010, INVENTOR_2_5 = 0x0020, INVENTOR_2_6 = 0x0040, COIN_1_0 = 0x0080, COIN_2_0 = 0x0100, EXTENSION = 0x0200, COIN_2_2 = 0x0400, COIN_2_3 = 0x0800, COIN_2_4 = 0x1000, INVENTOR_5_0 = 0x2000, COIN_2_5 = 0x4000, COIN_3_0 = 0x8000, INVENTOR_6_0 = 0x10000 }

## Public Member Functions

virtual SoType | getTypeId (void) const
| SoWWWInline (void)
void | setFullURLName (const SbString &url)
const SbString & | getFullURLName (void)
SoGroup * | copyChildren (void) const
void | requestURLData (void)
SbBool | isURLDataRequested (void) const
SbBool | isURLDataHere (void) const
void | cancelURLDataRequest (void)
void | setChildData (SoNode *urldata)
SoNode * | getChildData (void) const
virtual SoChildList * | getChildren (void) const
virtual void | doAction (SoAction *action)
virtual void | doActionOnKidsOrBox (SoAction *action)
virtual void | callback (SoCallbackAction *action)
virtual void | GLRender (SoGLRenderAction *action)
virtual void | getBoundingBox (SoGetBoundingBoxAction *action)
virtual void | getMatrix (SoGetMatrixAction *action)
virtual void | handleEvent (SoHandleEventAction *action)
virtual void | search (SoSearchAction *action)
virtual void | pick (SoPickAction *action)
virtual void | getPrimitiveCount (SoGetPrimitiveCountAction *action)
virtual void | audioRender (SoAudioRenderAction *action)
Public Member Functions inherited from SoNode
void | setOverride (const SbBool state)
SbBool | isOverride (void) const
void | setNodeType (const NodeType type)
NodeType | getNodeType (void) const
virtual SoNode * | copy (SbBool copyconnections=FALSE) const
virtual SbBool | affectsState (void) const
virtual void | GLRenderBelowPath (SoGLRenderAction *action)
virtual void | GLRenderInPath (SoGLRenderAction *action)
virtual void | GLRenderOffPath (SoGLRenderAction *action)
virtual void | rayPick (SoRayPickAction *action)
virtual void | write (SoWriteAction *action)
virtual void | grabEventsSetup (void)
virtual void | grabEventsCleanup (void)
virtual void | startNotify (void)
virtual void | notify (SoNotList *l)
uint32_t | getNodeId (void) const
virtual void | writeInstance (SoOutput *out)
virtual SoNode * | addToCopyDict (void) const
virtual SoFieldContainer * | copyThroughConnection (void) const
Public Member Functions inherited from SoFieldContainer
void | setToDefaults (void)
SbBool | hasDefaultValues (void) const
SbBool | fieldsAreEqual (const SoFieldContainer *container) const
void | copyFieldValues (const SoFieldContainer *container, SbBool copyconnections=FALSE)
SbBool | set (const char *const fielddata)
void | get (SbString &fielddata)
virtual int | getFields (SoFieldList &l) const
virtual int | getAllFields (SoFieldList &l) const
virtual SoField * | getField (const SbName &name) const
virtual SoField * | getEventIn (const SbName &name) const
virtual SoField * | getEventOut (const SbName &name) const
SbBool | getFieldName (const SoField *const field, SbName &name) const
SbBool | enableNotify (const SbBool flag)
SbBool | isNotifyEnabled (void) const
SbBool | set (const char *fielddata, SoInput *input)
void | get (SbString &fielddata, SoOutput *out)
virtual SbBool | validateNewFieldValue (SoField *field, void *newval)
virtual void | addWriteReference (SoOutput *out, SbBool isfromfield=FALSE)
SbBool | getIsBuiltIn (void) const
virtual void | getFieldsMemorySize (size_t &managed, size_t &unmanaged) const
void | setUserData (void *userdata) const
void * | getUserData (void) const
Public Member Functions inherited from SoBase
void | ref (void) const
void | unref (void) const
void | unrefNoDelete (void) const
int32_t | getRefCount (void) const
void | touch (void)
SbBool | isOfType (SoType type) const
virtual SbName | getName (void) const
virtual void | setName (const SbName &newname)
void | addAuditor (void *const auditor, const SoNotRec::Type type)
void | removeAuditor (void *const auditor, const SoNotRec::Type type)
const SoAuditorList & | getAuditors (void) const
SbBool | shouldWrite (void)
void | assertAlive (void) const

## Static Public Member Functions

static SoType | getClassTypeId (void)
static void | initClass (void)
static void | setFetchURLCallBack (SoWWWInlineFetchURLCB *f, void *userdata)
static void | setBoundingBoxVisibility (BboxVisibility b)
static BboxVisibility | getBoundingBoxVisibility (void)
static void | setBoundingBoxColor (SbColor &c)
static const SbColor & | getBoundingBoxColor (void)
static void | setReadAsSoFile (SbBool onoff)
static SbBool | getReadAsSoFile (void)
Static Public Member Functions inherited from SoNode
static uint32_t | getCompatibilityTypes (const SoType &nodetype)
static SoType | getClassTypeId (void)
static SoNode * | getByName (const SbName &name)
static int | getByName (const SbName &name, SoNodeList &l)
static void | initClass (void)
static void | initClasses (void)
static uint32_t | getNextNodeId (void)
static int | getActionMethodIndex (const SoType type)
static void | getBoundingBoxS (SoAction *action, SoNode *node)
static void | GLRenderS (SoAction *action, SoNode *node)
static void | callbackS (SoAction *action, SoNode *node)
static void | getMatrixS (SoAction *action, SoNode *node)
static void | handleEventS (SoAction *action, SoNode *node)
static void | pickS (SoAction *action, SoNode *node)
static void | rayPickS (SoAction *action, SoNode *node)
static void | searchS (SoAction *action, SoNode *node)
static void | writeS (SoAction *action, SoNode *node)
static void | audioRenderS (SoAction *action, SoNode *node)
static void | getPrimitiveCountS (SoAction *action, SoNode *node)
Static Public Member Functions inherited from SoFieldContainer
static void | initClass (void)
static SoType | getClassTypeId (void)
static void | cleanupClass (void)
static void | initCopyDict (void)
static void | addCopy (const SoFieldContainer *orig, const SoFieldContainer *copy)
static SoFieldContainer * | checkCopy (const SoFieldContainer *orig)
static SoFieldContainer * | findCopy (const SoFieldContainer *orig, const SbBool copyconnections)
static void | copyDone (void)
Static Public Member Functions inherited from SoBase
static void | initClass (void)
static SoType | getClassTypeId (void)
static void | addName (SoBase *const base, const char *const name)
static void | removeName (SoBase *const base, const char *const name)
static void | incrementCurrentWriteCounter (void)
static void | decrementCurrentWriteCounter (void)
static SoBase * | getNamedBase (const SbName &name, SoType type)
static int | getNamedBases (const SbName &name, SoBaseList &baselist, SoType type)
static SbBool | read (SoInput *input, SoBase *&base, SoType expectedtype)
static void | setInstancePrefix (const SbString &c)
static void | setTraceRefs (SbBool trace)
static SbBool | getTraceRefs (void)
static SbBool | connectRoute (SoInput *input, const SbName &fromnodename, const SbName &fromfieldname, const SbName &tonodename, const SbName &tofieldname)
static SbBool | readRoute (SoInput *input)

## Public Attributes

SoSFString | name
SoSFVec3f | bboxCenter
SoSFVec3f | bboxSize
SoSFNode | alternateRep

## Protected Member Functions

virtual const SoFieldData * | getFieldData (void) const
virtual | ~SoWWWInline ()
virtual void | addBoundingBoxChild (SbVec3f center, SbVec3f size)
virtual SbBool | readInstance (SoInput *in, unsigned short flags)
virtual void | copyContents (const SoFieldContainer *fromfC, SbBool copyconnections)
Protected Member Functions inherited from SoNode
| SoNode (void)
virtual | ~SoNode ()
Protected Member Functions inherited from SoFieldContainer
| SoFieldContainer (void)
virtual | ~SoFieldContainer ()
Protected Member Functions inherited from SoBase
| SoBase (void)
virtual | ~SoBase ()
virtual void | destroy (void)
SbBool | hasMultipleWriteRefs (void) const
SbBool | writeHeader (SoOutput *out, SbBool isgroup, SbBool isengine) const
void | writeFooter (SoOutput *out) const
virtual const char * | getFileFormatName (void) const

## Static Protected Member Functions

static const SoFieldData ** | getFieldDataPtr (void)
Static Protected Member Functions inherited from SoNode
static const SoFieldData ** | getFieldDataPtr (void)
static void | setNextActionMethodIndex (int index)
static int | getNextActionMethodIndex (void)
static void | incNextActionMethodIndex (void)
static void | setCompatibilityTypes (const SoType &nodetype, const uint32_t bitmask)

## Additional Inherited Members

Protected Types inherited from SoBase
enum | BaseFlags { IS_ENGINE = 0x01, IS_GROUP = 0x02 }
Protected Attributes inherited from SoNode
uint32_t | uniqueId
Static Protected Attributes inherited from SoNode
static uint32_t | nextUniqueId = 1
static int | nextActionMethodIndex = 0

## Detailed Description

The SoWWWInline class is a node used to include data from an URL.

If the URL is not a local file, the application is responsible for supplying a callback to a function which will fetch the data of the URL.

As long as no data has been imported, the scenegraph representation of the node will be that of a bounding box enclosing the geometry we expect to fetch from the URL. The application is naturally also responsible for specifying the expected dimensions of the geometry.

If FetchURLCallBack isn't set, the alternateRep will be rendered instead.

FILE FORMAT/DEFAULTS:

WWWInline {
name "<Undefined file>"
bboxCenter 0 0 0
bboxSize 0 0 0
alternateRep NULL
}

Since
  SGI Inventor 2.1
  Coin 1.0

## Member Enumeration Documentation

enum SoWWWInline::BboxVisibility

Used to enumerate bbox rendering strategies.

Enumerator
NEVER | Never render bounding box.
UNTIL_LOADED | Render bounding box until children are loaded.
ALWAYS | Always render bounding box, event when children are loaded.

## Constructor & Destructor Documentation

SoWWWInline::SoWWWInline | ( | void | ) |  |

Constructor.

SoWWWInline::~SoWWWInline | ( | ) |  |

protectedvirtual

Destructor.

## Member Function Documentation

SoType SoWWWInline::getTypeId | ( | void | ) |  | const

virtual

Returns the type identification of an object derived from a class inheriting SoBase. This is used for run-time type checking and "downward" casting.

Usage example:

void foo(SoNode * node)
{
if (node->getTypeId() == SoFile::getClassTypeId()) {
SoFile * filenode = (SoFile *)node; // safe downward cast, knows the type
}
}

For application programmers wanting to extend the library with new nodes, engines, nodekits, draggers or others: this method needs to be overridden in all subclasses. This is typically done as part of setting up the full type system for extension classes, which is usually accomplished by using the pre-defined macros available through for instance Inventor/nodes/SoSubNode.h (SO_NODE_INIT_CLASS and SO_NODE_CONSTRUCTOR for node classes), Inventor/engines/SoSubEngine.h (for engine classes) and so on.

For more information on writing Coin extensions, see the class documentation of the toplevel superclasses for the various class groups.

Implements SoBase.

const SoFieldData * SoWWWInline::getFieldData | ( | void | ) |  | const

protectedvirtual

Returns a pointer to the class-wide field data storage object for this instance. If no fields are present, returns `NULL`.

Reimplemented from SoFieldContainer.

void SoWWWInline::setFullURLName | ( | const SbString & | url) |  |

If the SoWWWInline::name field specifies a relative URL, use this method to name the complete URL.

const SbString & SoWWWInline::getFullURLName | ( | void | ) |  |

If a full URL has been set with the SoWWWInline::setFullURLName() method, return it. If not, returns the value of the SoWWWInline::name field.

SoGroup * SoWWWInline::copyChildren | ( | void | ) |  | const

Returns a subgraph with a deep copy of the children of this node.

void SoWWWInline::requestURLData | ( | void | ) |  |

Start requesting URL data. This might trigger a callback to the callback set in SoWWWInline::setFetchURLCallBack().

SbBool SoWWWInline::isURLDataRequested | ( | void | ) |  | const

Returns `TRUE` if SoWWWInline::requestURLData() has been called without being canceled by SoWWWInline::cancelURLData().

SbBool SoWWWInline::isURLDataHere | ( | void | ) |  | const

Return `TRUE` if the current child data has been read from file/URL and set using setChildData().

void SoWWWInline::cancelURLDataRequest | ( | void | ) |  |

Can be used to signal that URL loading has been canceled. You should use this method if you intend to request URL data more than once.

void SoWWWInline::setChildData | ( | SoNode * | urldata) |  |

Manually set up the subgraph for this node. This should be used by the application to set the data that was read from the file/URL.

SoNode * SoWWWInline::getChildData | ( | void | ) |  | const

Returns the child data for this node. This can be data read from a file, from an URL, from the contents of SoWWWInline::alternateRep or that was manually set with SoWWWInline::setChildData().

SoChildList * SoWWWInline::getChildren | ( | void | ) |  | const

virtual

Returns the child list with the child data for this node.

Reimplemented from SoNode.

void SoWWWInline::setFetchURLCallBack | ( | SoWWWInlineFetchURLCB * | f,
|  | void * | userdata
| ) |  |

static

Sets the URL fetch callback. This will be used in SoWWWInline::readInstance() or when the user calls SoWWWInline::requestURLData(). FIXME: Shouldn't called on readInstance(), only when we need to render the node (or calculate the bbox if we don't have one). kintel 20060203.

void SoWWWInline::setBoundingBoxVisibility | ( | BboxVisibility | b) |  |

static

Sets the bounding box visibility strategy. The default is UNTIL_LOADED.

SoWWWInline::BboxVisibility SoWWWInline::getBoundingBoxVisibility | ( | void | ) |  |

static

Returns the bounding box visibility.

void SoWWWInline::setBoundingBoxColor | ( | SbColor & | c) |  |

static

Sets the bounding box color.

const SbColor & SoWWWInline::getBoundingBoxColor | ( | void | ) |  |

static

Returns the bounding box color.

void SoWWWInline::setReadAsSoFile | ( | SbBool | onoff) |  |

static

Sets whether children should be read from a local file, in the same manner as SoFile children are read.

If this is set to `TRUE`, the URL must point to a file on the local file system, as can be accessed by the standard C library fopen() call.

SbBool SoWWWInline::getReadAsSoFile | ( | void | ) |  |

static

Returns if children should be read from local files.

See Also
  setReadAsSoFile()

void SoWWWInline::doAction | ( | SoAction * | action) |  |

virtual

This function performs the typical operation of a node for any action.

Reimplemented from SoNode.

void SoWWWInline::doActionOnKidsOrBox | ( | SoAction * | action) |  |

virtual

This method should probably have been private in OIV. It is obsoleted in Coin. Let us know if you need it.

void SoWWWInline::callback | ( | SoCallbackAction * | action) |  |

virtual

Action method for SoCallbackAction.

Simply updates the state according to how the node behaves for the render action, so the application programmer can use the SoCallbackAction for extracting information about the scene graph.

Reimplemented from SoNode.

void SoWWWInline::GLRender | ( | SoGLRenderAction * | action) |  |

virtual

Action method for the SoGLRenderAction.

This is called during rendering traversals. Nodes influencing the rendering state in any way or who wants to throw geometry primitives at OpenGL overrides this method.

Reimplemented from SoNode.

void SoWWWInline::getBoundingBox | ( | SoGetBoundingBoxAction * | action) |  |

virtual

Action method for the SoGetBoundingBoxAction.

Calculates bounding box and center coordinates for node and modifies the values of the action to encompass the bounding box for this node and to shift the center point for the scene more towards the one for this node.

Nodes influencing how geometry nodes calculates their bounding box also overrides this method to change the relevant state variables.

Reimplemented from SoNode.

void SoWWWInline::getMatrix | ( | SoGetMatrixAction * | action) |  |

virtual

Action method for SoGetMatrixAction.

Updates action by accumulating with the transformation matrix of this node (if any).

Reimplemented from SoNode.

void SoWWWInline::handleEvent | ( | SoHandleEventAction * | action) |  |

virtual

Action method for SoHandleEventAction.

Inspects the event data from action, and processes it if it is something which this node should react to.

Nodes influencing relevant state variables for how event handling is done also overrides this method.

Reimplemented from SoNode.

void SoWWWInline::search | ( | SoSearchAction * | action) |  |

virtual

Action method for SoSearchAction.

Compares the search criteria from the action to see if this node is a match. Searching is done by matching up all criteria set up in the SoSearchAction – if any of the requested criteria is a miss, the search is not deemed successful for the node.

See Also
  SoSearchAction

Reimplemented from SoNode.

void SoWWWInline::pick | ( | SoPickAction * | action) |  |

virtual

Action method for SoPickAction.

Does common processing for SoPickAction action instances.

Reimplemented from SoNode.

void SoWWWInline::getPrimitiveCount | ( | SoGetPrimitiveCountAction * | action) |  |

virtual

Action method for the SoGetPrimitiveCountAction.

Calculates the number of triangle, line segment and point primitives for the node and adds these to the counters of the action.

Nodes influencing how geometry nodes calculates their primitive count also overrides this method to change the relevant state variables.

Reimplemented from SoNode.

void SoWWWInline::audioRender | ( | SoAudioRenderAction * | action) |  |

virtual

Action method for SoAudioRenderAction.

Does common processing for SoAudioRenderAction action instances.

Reimplemented from SoNode.

void SoWWWInline::addBoundingBoxChild | ( | SbVec3f | center,
|  | SbVec3f | size
| ) |  |

protectedvirtual

Convenience method that extends the current bounding box to include the box specified by center and size.

SbBool SoWWWInline::readInstance | ( | SoInput * | in,
|  | unsigned short | flags
| ) |  |

protectedvirtual

This method is mainly intended for internal use during file import operations.

It reads a definition of an instance from the input stream in. The input stream state points to the start of a serialized / persistant representation of an instance of this class type.

`TRUE` or `FALSE` is returned, depending on if the instantiation and configuration of the new object of this class type went ok or not. The import process should be robust and handle corrupted input streams by returning `FALSE`.

flags is used internally during binary import when reading user extension nodes, group nodes or engines.

Reimplemented from SoNode.

void SoWWWInline::copyContents | ( | const SoFieldContainer * | from,
|  | SbBool | copyconnections
| ) |  |

protectedvirtual

Makes a deep copy of all data of from into this instance, except external scenegraph references if copyconnections is `FALSE`.

This is the protected method that should be overridden by extension node / engine / dragger / whatever subclasses which needs to account for internal data that are not handled automatically.

For copying nodes from application code, you should not invoke this function directly, but rather call the SoNode::copy() function:

SoNode * mynewnode = templatenode->copy();

The same also goes for engines.

Make sure that when you override the copyContents() method in your extension class that you also make it call upwards to it's parent superclass in the inheritance hierarchy, as copyContents() in for instance SoNode and SoFieldContainer does important work. It should go something like this:

void
MyCoinExtensionNode::copyContents(const SoFieldContainer * from,
SbBool copyconnections)
{
// let parent superclasses do their thing (copy fields, copy
// instance name, etc etc)
SoNode::copyContents(from, copyconnections);
// [..then copy internal data..]
}

Reimplemented from SoNode.

## Member Data Documentation

SoSFString SoWWWInline::name

Name of file/URL where children should be read.

SoSFVec3f SoWWWInline::bboxCenter

Center of bounding box.

SoSFVec3f SoWWWInline::bboxSize

Size of bounding box.

SoSFNode SoWWWInline::alternateRep

Alternate representation. Used when children can't be read from name.

The documentation for this class was generated from the following files:

- SoWWWInline.h
- SoWWWInline.cpp

Copyright © 1998-2010 by Kongsberg Oil & Gas Technologies. All rights reserved.